//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#include "StdAfx.h"

#include "ExtVSFunc.h"

using namespace TesterModule;

namespace TesterModule
{
	// --------------------------------------------------------------------------------------------------------
	SFunctionDef	gArrFunctionDefs[] = {
		{
			/* fName */				"Add",
			/* fCategory */			"Test Category",
			/* fDescription */		"This is test function",
			/* fVersion */			0,
			/* fScope */			0,
			/* fHasReturnValue */	true,
			/* fParams */ {
				{ "p1",					kIntegerArgType },
				{ "p2",					kIntegerArgType },
				{ "RETURN",				kIntegerArgType },
				{ NULL,					kIntegerArgType },
				{ NULL,					kIntegerArgType },
				{ NULL,					kIntegerArgType },
				{ NULL,					kIntegerArgType },
				{ NULL,					kIntegerArgType },
				{ NULL,					kIntegerArgType },
				{ NULL,					kIntegerArgType },
				{ NULL,					kIntegerArgType }
			}
		},
		// TERMINATE
		{ NULL, NULL, NULL, 0, 0, FALSE, { {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType}, {NULL,kIntegerArgType} } }
	};
}

// --------------------------------------------------------------------------------------------------------
// {459E0DFD-A970-414C-9959-477814C8BB3F}
BEGIN_VWVSFunctions(
	/*Extension class*/	CExtVSFuncs,
	/*Universal name*/	"CExtVSFuncs_VWPluginWiz1",
	/*Version*/			1,
	/*UUID*/			0x459e0dfd, 0xa970, 0x414c, 0x99, 0x59, 0x47, 0x78, 0x14, 0xc8, 0xbb, 0x3f );
ADD_VWVSFunctions_ROUTINE( CMyVSRoutines );
END_VWVSFunctions;

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtVSFuncs::CExtVSFuncs(CallBackPtr cbp)
	: VWExtensionVSFunctions( cbp, gArrFunctionDefs )
{
}

CExtVSFuncs::~CExtVSFuncs()
{
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
// define dispatch map
BEGIN_LIB_DISPATCH_MAP_Ex( CMyVSRoutines, gArrFunctionDefs );
	ADD_LIB_FUNCTION_Ex( "Add",			OnAdd	);
END_LIB_DISPATCH_MAP_Ex;

// --------------------------------------------------------------------------------------------------------
CMyVSRoutines::CMyVSRoutines()
{
}

CMyVSRoutines::~CMyVSRoutines()
{
}

PluginLibraryInitFlags CMyVSRoutines::InitPluginLibrary()
{
	return PluginLibraryInitFlags(0);
}

void CMyVSRoutines::OnAdd(VWPluginLibraryArgTable& argTable)
{
	short	a	= argTable.GetArgument(0).GetArgInteger();
	short	b	= argTable.GetArgument(1).GetArgInteger();

	argTable.GetResult().SetArgInteger( a + b );
}

