//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#include "StdAfx.h"

#include "Obj_ShapePane.h"

using namespace TesterModule;

namespace TesterModule
{
	// --------------------------------------------------------------------------------------------------------
	const Sint32	kWidgetID_P1		= 1;
	const Sint32	kWidgetID_P2		= 2;
	const Sint32	kWidgetID_P3		= 3;
	const Sint32	kWidgetID_P4		= 4;
	const Sint32	kWidgetID_P5		= 5;
	const Sint32	kWidgetID_P6		= 6;
	const Sint32	kWidgetID_P7		= 7;
	const Sint32	kWidgetID_Settings	= 8;
}

// --------------------------------------------------------------------------------------------------------
CObj_ShapePane::CObj_ShapePane(IVWUnknown* parent)
	: VCOMImpl<IProviderShapePane>( parent )
{
}

CObj_ShapePane::~CObj_ShapePane()
{
}

void CObj_ShapePane::Init(CodeRefID objectID, IExtendedProps* extProps)
{
	VWFC::PluginSupport::CWidgetsEditProvider	widgetProvider( extProps, objectID );

	widgetProvider.AddWidget( kWidgetID_P1,		"p1" );
	widgetProvider.AddWidget( kWidgetID_P2,		"p2" );
	widgetProvider.AddWidget( kWidgetID_P3,		"p3" );
	widgetProvider.AddWidget( kWidgetID_P4,		"p4" );
	widgetProvider.AddWidget( kWidgetID_P5,		"p5" );
	widgetProvider.AddWidget( kWidgetID_P6,		"p6" );
	widgetProvider.AddWidget( kWidgetID_P7,		"p7" );
	widgetProvider.AddWidget( kWidgetID_Settings, kWidgetButton, TXResStr("CExtObj", "shapePane_Widget_SettingsButton") );
}

void CObj_ShapePane::Activate(MCObjectHandle hObject, const SSelectionContext& selContext)
{
}

void CObj_ShapePane::Deactivate()
{
}

void CObj_ShapePane::Update(IWidgetsProvider* widgetProvider)
{
}



